require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__x8664_PCI_H)) {
    eval 'sub __x8664_PCI_H () {1;}' unless defined(&__x8664_PCI_H);
    require 'linux/config.ph';
    require 'asm/io.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_PCI)) {
	} else {
	    eval 'sub pcibios_assign_all_busses () {
	        eval q(0);
	    }' unless defined(&pcibios_assign_all_busses);
	}
	eval 'sub PCIBIOS_MIN_IO () {0x1000;}' unless defined(&PCIBIOS_MIN_IO);
	eval 'sub PCIBIOS_MIN_MEM () {( &pci_mem_start);}' unless defined(&PCIBIOS_MIN_MEM);
	require 'linux/types.ph';
	require 'linux/slab.ph';
	require 'asm/scatterlist.ph';
	require 'linux/string.ph';
	require 'asm/io.ph';
	require 'asm/page.ph';
	require 'asm/mmzone.ph';
	if(defined(&CONFIG_GART_IOMMU)) {
	    eval 'sub pci_map_page {
	        local($dev,$page,$offset,$size,$dir) = @_;
    		eval q( &pci_map_single(($dev),  &page_address($page)+($offset), ($size), ($dir)));
	    }' unless defined(&pci_map_page);
	    eval 'sub DECLARE_PCI_UNMAP_ADDR {
	        local($ADDR_NAME) = @_;
    		eval q( &dma_addr_t $ADDR_NAME;);
	    }' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	    eval 'sub DECLARE_PCI_UNMAP_LEN {
	        local($LEN_NAME) = @_;
    		eval q( &__u32 $LEN_NAME;);
	    }' unless defined(&DECLARE_PCI_UNMAP_LEN);
	    eval 'sub pci_unmap_addr {
	        local($PTR, $ADDR_NAME) = @_;
    		eval q((($PTR)->$ADDR_NAME));
	    }' unless defined(&pci_unmap_addr);
	    eval 'sub pci_unmap_addr_set {
	        local($PTR, $ADDR_NAME, $VAL) = @_;
    		eval q(((($PTR)->$ADDR_NAME) = ($VAL)));
	    }' unless defined(&pci_unmap_addr_set);
	    eval 'sub pci_unmap_len {
	        local($PTR, $LEN_NAME) = @_;
    		eval q((($PTR)->$LEN_NAME));
	    }' unless defined(&pci_unmap_len);
	    eval 'sub pci_unmap_len_set {
	        local($PTR, $LEN_NAME, $VAL) = @_;
    		eval q(((($PTR)->$LEN_NAME) = ($VAL)));
	    }' unless defined(&pci_unmap_len_set);
	    eval 'sub PCI_DMA_BUS_IS_PHYS () {(0);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	} else {
	    eval 'sub DECLARE_PCI_UNMAP_ADDR {
	        local($ADDR_NAME) = @_;
    		eval q();
	    }' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	    eval 'sub DECLARE_PCI_UNMAP_LEN {
	        local($LEN_NAME) = @_;
    		eval q();
	    }' unless defined(&DECLARE_PCI_UNMAP_LEN);
	    eval 'sub pci_unmap_addr {
	        local($PTR, $ADDR_NAME) = @_;
    		eval q((0));
	    }' unless defined(&pci_unmap_addr);
	    eval 'sub pci_unmap_addr_set {
	        local($PTR, $ADDR_NAME, $VAL) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pci_unmap_addr_set);
	    eval 'sub pci_unmap_len {
	        local($PTR, $LEN_NAME) = @_;
    		eval q((0));
	    }' unless defined(&pci_unmap_len);
	    eval 'sub pci_unmap_len_set {
	        local($PTR, $LEN_NAME, $VAL) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pci_unmap_len_set);
	    eval 'sub PCI_DMA_BUS_IS_PHYS () {1;}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	}
	eval 'sub pci_unmap_page () { &pci_unmap_single;}' unless defined(&pci_unmap_page);
	eval 'sub pci_dac_dma_supported {
	    local($pci_dev, $mask) = @_;
    	    eval q((1));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub sg_dma_address {
	    local($sg) = @_;
    	    eval q((($sg)-> &dma_address));
	}' unless defined(&sg_dma_address);
	eval 'sub sg_dma_len {
	    local($sg) = @_;
    	    eval q((($sg)-> &length));
	}' unless defined(&sg_dma_len);
	eval 'sub HAVE_PCI_MMAP () {1;}' unless defined(&HAVE_PCI_MMAP);
    }
}
1;
