require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__X86_64_UACCESS_H)) {
    eval 'sub __X86_64_UACCESS_H () {1;}' unless defined(&__X86_64_UACCESS_H);
    require 'linux/config.ph';
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    require 'linux/prefetch.ph';
    require 'asm/page.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub MAKE_MM_SEG {
        local($s) = @_;
	    eval q((( &mm_segment_t) { ($s) }));
    }' unless defined(&MAKE_MM_SEG);
    eval 'sub KERNEL_DS () { &MAKE_MM_SEG(0xffffffffffffffff);}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () { &MAKE_MM_SEG( &PAGE_OFFSET);}' unless defined(&USER_DS);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( ($current->{addr_limit})));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        local($x) = @_;
	    eval q(( ($current->{addr_limit}) = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        local($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __addr_ok {
        local($addr) = @_;
	    eval q((!(($addr) & ( ($current->{addr_limit}->{seg})))));
    }' unless defined(&__addr_ok);
    eval 'sub __range_not_ok {
        local($addr,$size) = @_;
	    eval q(({ \'unsigned long flag\', &sum;  &asm(\\"# range_ok\\\\n\\\\r\\" \\"addq %3,%1 ; sbbq %0,%0 ; cmpq %1,%4 ; sbbq $0,%0\\" :\\"=&r\\" , \\"=r\\" :\\"1\\" ,\\"g\\" (($size)),\\"g\\" ( ($current->{addr_limit}->{seg})));  &flag; }));
    }' unless defined(&__range_not_ok);
    eval 'sub access_ok {
        local($type,$addr,$size) = @_;
	    eval q(( &__range_not_ok($addr,$size) == 0));
    }' unless defined(&access_ok);
1;
