require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XMMS_SAVE)) {
    sub XMMS_SAVE () {	 &asm  &volatile ( "movq %%cr0,%0		;\n\t" "clts			;\n\t" "movups %%xmm0,(%1)	;\n\t" "movups %%xmm1,0x10(%1)	;\n\t" "movups %%xmm2,0x20(%1)	;\n\t" "movups %%xmm3,0x30(%1)	;\n\t" : "=&r" ( &cr0) : "r" ( &xmm_save) : "memory");}
}
unless(defined(&XMMS_RESTORE)) {
    sub XMMS_RESTORE () {	 &asm  &volatile ( "sfence			;\n\t" "movups (%1),%%xmm0	;\n\t" "movups 0x10(%1),%%xmm1	;\n\t" "movups 0x20(%1),%%xmm2	;\n\t" "movups 0x30(%1),%%xmm3	;\n\t" "movq 	%0,%%cr0	;\n\t" : : "r" ( &cr0), "r" ( &xmm_save) : "memory");}
}
unless(defined(&OFFS)) {
    sub OFFS {
	local($x) = @_;
	eval q(\"16*(\"$x\")\");
    }
}
unless(defined(&PF_OFFS)) {
    sub PF_OFFS {
	local($x) = @_;
	eval q(\"320+16*(\"$x\")\");
    }
}
unless(defined(&PF0)) {
    sub PF0 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p1])		;\\n\");
    }
}
unless(defined(&LD)) {
    sub LD {
	local($x,$y) = @_;
	eval q(\"       movaps   \" &OFFS($x)\"(%[p1]), %%xmm\"$y\"	;\\n\");
    }
}
unless(defined(&ST)) {
    sub ST {
	local($x,$y) = @_;
	eval q(\"       movntdq %%xmm\"$y\",   \" &OFFS($x)\"(%[p1])	;\\n\");
    }
}
unless(defined(&PF1)) {
    sub PF1 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p2])		;\\n\");
    }
}
unless(defined(&PF2)) {
    sub PF2 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p3])		;\\n\");
    }
}
unless(defined(&PF3)) {
    sub PF3 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p4])		;\\n\");
    }
}
unless(defined(&PF4)) {
    sub PF4 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p5])		;\\n\");
    }
}
unless(defined(&PF5)) {
    sub PF5 {
	local($x) = @_;
	eval q(\"	prefetchnta \" &PF_OFFS($x)\"(%[p6])		;\\n\");
    }
}
unless(defined(&XO1)) {
    sub XO1 {
	local($x,$y) = @_;
	eval q(\"       xorps   \" &OFFS($x)\"(%[p2]), %%xmm\"$y\"	;\\n\");
    }
}
unless(defined(&XO2)) {
    sub XO2 {
	local($x,$y) = @_;
	eval q(\"       xorps   \" &OFFS($x)\"(%[p3]), %%xmm\"$y\"	;\\n\");
    }
}
unless(defined(&XO3)) {
    sub XO3 {
	local($x,$y) = @_;
	eval q(\"       xorps   \" &OFFS($x)\"(%[p4]), %%xmm\"$y\"	;\\n\");
    }
}
unless(defined(&XO4)) {
    sub XO4 {
	local($x,$y) = @_;
	eval q(\"       xorps   \" &OFFS($x)\"(%[p5]), %%xmm\"$y\"	;\\n\");
    }
}
unless(defined(&XO5)) {
    sub XO5 {
	local($x,$y) = @_;
	eval q(\"       xorps   \" &OFFS($x)\"(%[p6]), %%xmm\"$y\"	;\\n\");
    }
}
undef(&BLOCK) if defined(&BLOCK);
unless(defined(&BLOCK)) {
    sub BLOCK {
	local($i) = @_;
	eval q( &LD($i,0)  &LD($i+1,1)  &PF1  &LD($i+2,2)  &LD($i+3,3)  &PF0($i+4)  &XO1($i,0)  &XO1($i+1,1)  &ST($i,0)  &ST($i+1,1)  &XO1($i+2,2)  &XO1($i+3,3)  &ST($i+2,2)  &ST($i+3,3));
    }
}
undef(&BLOCK) if defined(&BLOCK);
unless(defined(&BLOCK)) {
    sub BLOCK {
	local($i) = @_;
	eval q( &PF1  &LD($i,0)  &LD($i+1,1)  &XO1($i,0)  &XO1($i+1,1)  &LD($i+2,2)  &LD($i+3,3)  &PF2  &PF0($i+4)  &XO1($i+2,2)  &XO1($i+3,3)  &XO2($i,0)  &XO2($i+1,1)  &ST($i,0)  &ST($i+1,1)  &XO2($i+2,2)  &XO2($i+3,3)  &ST($i+2,2)  &ST($i+3,3));
    }
}
undef(&BLOCK) if defined(&BLOCK);
unless(defined(&BLOCK)) {
    sub BLOCK {
	local($i) = @_;
	eval q( &PF1  &LD($i,0)  &LD($i+1,1)  &XO1($i,0)  &XO1($i+1,1)  &LD($i+2,2)  &LD($i+3,3)  &PF2  &XO1($i+2,2)  &XO1($i+3,3)  &PF3  &PF0($i+4)  &XO2($i,0)  &XO2($i+1,1)  &XO2($i+2,2)  &XO2($i+3,3)  &XO3($i,0)  &XO3($i+1,1)  &ST($i,0)  &ST($i+1,1)  &XO3($i+2,2)  &XO3($i+3,3)  &ST($i+2,2)  &ST($i+3,3));
    }
}
undef(&BLOCK) if defined(&BLOCK);
unless(defined(&BLOCK)) {
    sub BLOCK {
	local($i) = @_;
	eval q( &PF1  &LD($i,0)  &LD($i+1,1)  &XO1($i,0)  &XO1($i+1,1)  &LD($i+2,2)  &LD($i+3,3)  &PF2  &XO1($i+2,2)  &XO1($i+3,3)  &PF3  &XO2($i,0)  &XO2($i+1,1)  &XO2($i+2,2)  &XO2($i+3,3)  &PF4  &PF0($i+4)  &XO3($i,0)  &XO3($i+1,1)  &XO3($i+2,2)  &XO3($i+3,3)  &XO4($i,0)  &XO4($i+1,1)  &ST($i,0)  &ST($i+1,1)  &XO4($i+2,2)  &XO4($i+3,3)  &ST($i+2,2)  &ST($i+3,3));
    }
}
if((defined(&__GNUC__) ? &__GNUC__ : 0) > 3|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 3 && (defined(&__GNUC__MINOR__) ? &__GNUC__MINOR__ : 0) >= 3)) {
    eval 'sub STORE_NTI {
        local($x,$mem) = @_;
	    eval q( &__builtin_ia32_movnti(($mem), ($x)));
    }' unless defined(&STORE_NTI);
} else {
    eval 'sub STORE_NTI {
        local($x,$mem) = @_;
	    eval q( &asm(\\"movnti %1,%0\\" : \\"=m\\" ($mem) : \\"r\\" ($x)));
    }' unless defined(&STORE_NTI);
}
undef(&XOR_TRY_TEMPLATES) if defined(&XOR_TRY_TEMPLATES);
unless(defined(&XOR_TRY_TEMPLATES)) {
    sub XOR_TRY_TEMPLATES () {	 &do {  &xor_speed( &xor_block_sse);  &xor_speed( &xor_block_64regs_stream); }  &while (0);}
}
unless(defined(&XOR_SELECT_TEMPLATE)) {
    sub XOR_SELECT_TEMPLATE {
	local($FASTEST) = @_;
	eval q(($FASTEST));
    }
}
1;
